1 '     save "AUTOEXEC.BAS"
2 '     save "TORSOAFD.BAS",a
3 '     screen 6:set page 0,3:vpoke &h7fff,0
10 ' ----- ----- ----- ----- -----
20 ' MSXdriver Torso April Fools' Day Version
30 ' 2023 / 04 / 01
40 ' Written by Kotoni Kaido
50 ' ----- ----- ----- ----- -----
60 GOTO 1010
98 '456789-123456789-123456789-123456789-123456789-123456789-123456789-12345678
99 ' ===== ===== Subroutine
100 ' ===== Box
110 LINE(RND(1)*512,RND(1)*212)-(RND(1)*512,RND(1)*212),C,BF,PSET
120 RETURN
200 ' ===== Footer
210 S$="aqua.flv - slide "+RIGHT$("000"+MID$(STR$(SN),2),4):IF NF=0 THEN 260
220 POKE VARPTR(SA),PEEK(VARPTR(S$)+1):POKE VARPTR(SA)+1,PEEK(VARPTR(S$)+2)
230 FOR I=SA TO SA+20
240  IF RND(1)>.7 THEN POKE I,&H7B+RND(1)*4
250 NEXT I
260 PSET(8,200),0,OR:PRINT #1,S$;:IF SN>999 THEN PRINT #1,"   Seriously, are you insane?";
270 SN=SN+1:IF SN=10000 THEN SN=0   ' Really, seriously, are you insane?
280 RETURN
300 ' ===== Sound
310 SW=RND(1)*136+64
320 IF ABS(SD-SW)<3 THEN 310
330 SD=SW
340 S7=&B111110:IF NF THEN S7=&B101110
350 SOUND 0,SD:SOUND 6,RND(1)*4
360 SOUND 7,S7
370 RETURN
400 ' ===== Switch page ( no wait )
410 VDP(2)=R2+PG*&H20          ' View page
420 PG=-(PG=0)
430 POKE &HFAF6,PG
440 POKE &HF923,PG*&H80        ' Write page
450 CLS
460 RETURN
500 ' ===== Switch page
510 IF PN=31 THEN SZ=0:AT=&H10 ELSE SZ=1:AT=(PN AND &H20) \ 4
520 PT=PN AND &H1F
530 IF TIME<WT THEN 530
540 IF SP=2 THEN 570
550 VDP(5)=R5+AT:VDP(6)=R6+PT  ' Sprite page
560 VDP(1)=R1+SZ               ' Sprite size
570 VDP(2)=R2+PG*&H20          ' View page
580 VDP(9)=R8+SP               ' Sprite On/Off
590 TIME=0                     ' Reset timer
600 PG=-(PG=0)
610 POKE &HFAF6,PG
620 POKE &HF923,PG*&H80        ' Write page
630 CLS
640 RETURN
700 ' ===== Switch Sprite page
710 IF TIME<AW THEN 710
720 AT=(PN AND &H20) \ 4:PT=PN AND &H1F
730 VDP(5)=R5+AT:VDP(6)=R6+PT   ' Sprite page
740 TIME=0                      ' Reset timer
750 RETURN
800 ' ===== CPU Check / CP 0:Z80 1:R800
810 CP=0:TIME=0
820 FOR I=0 TO 500:NEXT I
830 IF TIME<20 THEN CP=1
840 RETURN
1000 ' ===== ===== ===== ===== Memory Initialize
1010 CLEAR 300,&HC000
1020 DEFINT A-Z
1030 DIM AC(6)              ' Animetion count
1040 DIM AP(6,2)            ' Animetion pattern
1200 ' ===== ===== Initialize variables
1210 MD=0                   ' Movie mode 0:normal 1:movie
1220 OT=85                  ' Original torso probability
1230 LS=0                   ' Movie work
1240 R1=0                   ' VDP(1) Mode register 1
1250 R2=0                   ' VDP(2) Pattern name table
1260 R5=&HE7                ' VDP(5) Sprite attribute table(7200H)
1270 R6=&H20                ' VDP(6) Sprite pattern generator table (10000H-1FFFFH)
1280 R8=0                   ' VDP(9) Mode register 2
1290 SZ=1                   ' VDP(1) Sprite size 0:normal / 1:double
1300 PG=0                   ' VDP(2) View/Write page
1310 AT=0                   ' VDP(5) Sprite attribute work
1320 PT=0                   ' VDP(6) Sprite pattern work
1330 SP=2                   ' VDP(9) Sprite 0:On / 2:Off
1340 X=0:Y=0                ' Sprite position work
1350 X0=0:Y0=0:X1=0:Y1=0    ' Sprite Neko position 0/1
1360 X2=0:Y2=0:X3=0:Y3=0    ' Sprite Neko position 2/3
1370 CT=2                   ' Small Neko probability
1380 CF=0                   ' Small Neko flag
1390 AN=0                   ' Animation number
1400 PA=9                   ' Previous Animation number
1410 PN=0                   ' Animation pattern number
1420 CL=0                   ' Box color 1:Blue / 2:Red
1430 WT=60                  ' Wait time
1440 AW=5                   ' Animation wait time
1450 R=0                    ' Randomize
1460 SN=0                   ' Footer Slide number
1470 SD=0:SW=0:S7=0         ' Sound
1480 I=0:J=0                ' Loop index
1490 SA=0                   ' Footer variable address
1500 NF=0                   ' Noise footer flag
1510 S$=STRING$(32,32)      ' Footer work
1520 DT$="00:00:00"         ' Get date time
1600 ' ----- Randomize
1610 GET TIME DT$:R=VAL(LEFT$(DT$,2))*1000+VAL(MID$(DT$,4,2)+RIGHT$(DT$,2))
1620 GET DATE DT$:R=R+VAL(MID$(DT$,4,2)+RIGHT$(DT$,2))
1630 R=RND(-R)
1700 ' ----- Animetion pattern
1710 GOSUB 810:WK=CP*2                  ' ----- CPU Check
1720 AP(0,0)=31:AP(0,1)=31:AP(0,2)=0    ' Small Neko
1730 AP(1,0)=0:AP(1,1)=19:AP(1,2)=3+WK  ' Tsujino Akari
1740 AP(2,0)=20:AP(2,1)=30:AP(2,2)=3+WK ' Ringoro
1750 AP(3,0)=32:AP(3,1)=49:AP(3,2)=3+WK ' Rick Astley
1760 AP(4,0)=50:AP(4,1)=60:AP(4,2)=4+WK ' Kizuna Akari
1770 AP(5,0)=61:AP(5,1)=62:AP(5,2)=60   ' Neko death
1780 AP(6,0)=61:AP(6,1)=62:AP(6,2)=0    ' Neko death(END)
1900 '===== ===== Function
1910 ' Random probability
1920 DEFFNR(P)=(RND(1)*100)<P
1930 ' Sprite attribute table address 7200H , 7600H , 7A00H , 7E00H
1940 DEFFNP(P)=&H72+P*4
2000 ' ===== ===== Sound initialize
2010 SOUND 7,&B111111
2020 SOUND 1,0:SOUND 8,15
2030 SOUND 6,0:SOUND 9,11
2100 ' ===== ===== Screen initialize
2110 SCREEN 6,3,0
2120 COLOR 3,0,0
2130 COLOR=(0,7,7,7):COLOR=(1,0,0,7):COLOR=(2,7,0,0):COLOR=(3,0,0,0)
2140 OPEN "GRP:" AS #1
2150 SET PAGE 0,0:CLS:COPY(0,0)-(511,44),0 TO (0,211),0
2200 ' ===== ===== Loading message
2210 SET PAGE 0,0:PSET(0,8),0
2220 PRINT #1," MSXdriver Torso - April Fools' Day Version"
2230 PRINT #1," MSX Porting by K.K"
2240 PRINT #1,""
2250 PRINT #1," CPU:";MID$("Z80 R800",CP*4+1,4)
2300 ' ===== ===== Font Bold
2310 IF PEEK(&HF921)=&HC0 THEN 2610
2320 PRINT #1," Font setting ...":LINE(137,40)-STEP(92,6),3,B
2330 KEY 6,"POKE-1761,"+STR$(PEEK(&HF91F)):KEY 7,":POKE-1760,"+STR$(PEEK(&HF920)):KEY 8,":POKE-1759,"+STR$(PEEK(&HF921))+CHR$(13)
2340 AD=PEEK(&HF921)*256+PEEK(&HF920)
2350 FOR I=&H20 TO &H7A:LINE(106+I,40)-STEP(0,5),3
2360  FOR J=0 TO 7
2370   FW=PEEK(AD+I*8+J)
2380   POKE &HC000+I*8+J,FW OR (FW \ 2)
2390  NEXT J
2400 NEXT I
2410 ' Noise character
2420 FOR I=&H7B*8 TO &H7E*8-1
2430  POKE &HC000+I,INT(RND(1)*128)*2
2440 NEXT I
2450 ' Box character
2460 FOR I=&H7E*8 TO &H7F*8-1
2470  POKE &HC000+I,&HFE
2480 NEXT I
2490 ' "0" character (no stroke)
2500 FOR I=0 TO 7
2510  POKE &HC000+ASC("0")*8+I,VAL("&H"+MID$("78CCCCCCCCCC7800",I*2+1,2))
2520 NEXT I
2550 ' Font Address
2560 POKE &HF91F,PEEK(&HF344):POKE &HF920,&H0:POKE &HF921,&HC0
2600 ' ===== ===== Sprite data load
2610 SET PAGE 0,3:IF VPEEK(&H7FFF)=&HA5 THEN 2710
2620 SET PAGE 0,0:PSET(0,48),0:PRINT #1," Loading ... DATA(1)"
2630 SET PAGE 0,2:CLS:BLOAD "SPRITE0.DAT",S
2640 SET PAGE 0,0:PSET(0,56),0:PRINT #1," Loading ... DATA(2)"
2650 SET PAGE 0,3:CLS:BLOAD "SPRITE1.DAT",S
2700 ' ===== ===== Sprite animetion
2710 SET PAGE 0,0:PSET(0,64),0:PRINT #1," Sprite setting ..."
2720 FOR Y=0 TO 4
2730  FOR X=0 TO 5
2740   POKE &HF929,FNP(0)
2750   PUT SPRITE X+Y*6,(32+X*32,26+Y*32),&B1010,X+Y*6
2760   POKE &HF929,FNP(1)
2770   PUT SPRITE X+Y*6,(32+X*32,26+Y*32),&B1010,32+X+Y*6
2780  NEXT X
2790 NEXT Y
2800 ' ----- Small Neko
2810 POKE &HF929,FNP(2)
2820 PUT SPRITE 0,(0,216),&B1010,0
2830 PUT SPRITE 1,(0,216),&B1010,1
2840 PUT SPRITE 2,(0,216),&B1010,2
2850 PUT SPRITE 3,(0,216),&B1010,3
2860 PUT SPRITE 4,(0,216),,0
2900 ' ===== ===== Fadeout screen
2910 FOR I=0 TO 7
2920  COLOR=(3,I,I,I)
2930  TIME=0
2940  IF TIME<3 THEN 2940
2950 NEXT I
2960 CLS:PSET(0,0),0
2970 COLOR=(3,0,0,0)
3000 ' ===== ===== ===== ===== Start screen setting
3010 R1=VDP(1) AND &HFE
3020 R2=VDP(2)
3030 R5=&HE7
3040 R6=&H20
3050 R8=VDP(9) AND &HFD
3060 TIME=WT            ' no wait
3070 PG=0               ' View page 0 / Write page 1
3080 SP=2               ' Sprite off
3090 GOSUB 510          ' Switch page
3100 ' ===== ===== ===== ===== Main
3110 AN=0               ' Clear Animetion number
3120 IF FNR(OT) OR (SP=0) THEN 3210     ' (OT)% in original torso
3130 IF (MD=0) AND (SN<30) THEN 3210
3140 AN=RND(1)*5+1      ' Animetion number
3150 IF AN=PA THEN 3140 ' Not selecting the same animation.
3160 IF (AN=5) AND (CF=0) THEN 3140 ' Not selected until you see the small neko.
3170 PA=AN              ' Previous Animation number
3200 ' ----- Input
3210 K$=INKEY$
3220 IF K$="" THEN 3310
3230 AN=VAL(K$)
3240 IF AN>6 THEN AN=0
3300 ' ----- Movie mode (YT/Nico)
3310 IF MD=0 THEN 3910
3320 IF SN<56 THEN AN=0
3330 IF SN=10 THEN AN=1     ' Tsujino Akari
3340 IF SN=20 THEN AN=2     ' Ringoro
3350 IF SN=30 THEN AN=4     ' Kizuna Akari
3360 IF SN=40 THEN AN=3     ' Rick Astley
3370 'IF SN=50 THEN AN=5     ' Neko death
3380 IF SN<185 THEN 3910
3400 ' Choose from the animation list.
3410 LS=LS+1:AN=VAL(MID$("00304020106",LS,1))
3900 ' -----
3910 AC(AN)=AC(AN)+1
3920 IF AC(AN)=&H7FFF THEN AC(AN)=0 ' Seriously, are you insane?
3930 IF AN=0 THEN GOSUB 4010 ELSE GOSUB 5010
3940 GOTO 3110
4000 ' ----- ----- Original torso
4010 GOSUB 4210             ' Small Neko
4020 C=1:GOSUB 110          ' Draw Box Blue
4030 C=2:GOSUB 110          ' Draw Box Red
4040 GOSUB 210              ' Draw Footer
4050 GOSUB 510              ' Switch page
4060 GOSUB 310              ' Sound
4070 RETURN
4200 ' ----- Small Neko
4210 IF MD AND (SN=50) THEN 4250
4220 IF K$="0" THEN 4250
4230 IF (SP=0) OR (SN<60) THEN SP=2:NF=0:RETURN
4240 IF FNR(CT)=0 THEN RETURN
4250 SP=0:CF=1:NF=1     ' Sprite on / Neko on / Noise footer
4260 PN=AP(AN,0)        ' Neko sprite
4270 AC(6)=AC(6)+1      ' Small Neko count
4280 IF AC(6)=&H7FFF THEN AC(6)=0 ' Seriously, are you insane?
4300 X0=224+RND(1)*24:Y0=128+RND(1)*76
4310 X1=X0+16:Y1=Y0:IF X1>255 THEN X1=0:Y1=217
4320 X2=X0:Y2=Y0+16:IF Y2>211 THEN X2=0:Y2=217
4330 X3=X0+16:Y3=Y0+16:IF (X3>255) OR (Y3>211) THEN X3=0:Y3=217
4340 POKE &HFAF6,0
4350 VPOKE &H7A00,Y0:VPOKE &H7A01,X0
4360 VPOKE &H7A04,Y1:VPOKE &H7A05,X1
4370 VPOKE &H7A08,Y2:VPOKE &H7A09,X2
4380 VPOKE &H7A0C,Y3:VPOKE &H7A0D,X3
4390 POKE &HFAF6,PG
4400 RETURN
5000 ' ----- ----- Animation
5010 AW=AP(AN,2)        ' Anime wait time
5020 IF AN>4 THEN NF=1 ELSE NF=0	' Noise footer
5030 SP=0               ' Sprite on
5040 PN=AP(AN,0)        ' First Animation pattern number
5050 C=1:GOSUB 110      ' Draw Box Blue
5060 GOSUB 210          ' Draw Footer
5070 GOSUB 510          ' Switch page
5080 GOSUB 310          ' Sound
5090 C=1:GOSUB 110      ' Draw Box Blue
5100 GOSUB 210          ' Draw Footer
5110 ON AN GOSUB 5210,5410,5610,5810,6010,6210,6210
5120 RETURN
5200 ' ----- 1 Tsujino Akari
5210 FOR PN=AP(AN,0)+1 TO AP(AN,1)
5220  GOSUB 710         ' Sprite page
5230  IF PN=10 THEN GOSUB 410:GOSUB 310 ' switch page(nw) / Sound
5240 NEXT PN
5250 PN=AP(AN,0):GOSUB 710
5260 TIME=WT-AW
5270 RETURN
5400 ' ----- 2 Ringoro
5410 FOR PN=AP(AN,0)+1 TO AP(AN,1)
5420  GOSUB 710         ' Sprite page
5430 NEXT PN
5440 GOSUB 410          ' Switch page(nw)
5450 GOSUB 310          ' Sound
5460 FOR PN=AP(AN,1)-1 TO AP(AN,0) STEP -1
5470  GOSUB 710         ' Sprite page
5480 NEXT PN
5490 PN=AP(AN,0):GOSUB 710
5500 TIME=WT-AW
5510 RETURN
5600 ' ----- 3 Rick Astley
5610 FOR PN=AP(AN,0)+1 TO AP(AN,1)
5620  GOSUB 710         ' Sprite page
5630 NEXT PN
5640 GOSUB 410          ' Switch page(nw)
5650 GOSUB 310          ' Sound
5660 FOR PN=AP(AN,0) TO AP(AN,1)
5670  GOSUB 710         ' Sprite page
5680 NEXT PN
5690 TIME=WT-AW
5700 RETURN
5800 ' ----- 4 Kizuna Akari
5810 FOR PN=AP(AN,0)+1 TO AP(AN,1)
5820  GOSUB 710         ' Sprite page
5830 NEXT PN
5840 GOSUB 410          ' Switch page(nw)
5850 GOSUB 310          ' Sound
5860 FOR PN=AP(AN,0) TO AP(AN,1)
5870  GOSUB 710         ' Sprite page
5880 NEXT PN
5890 PN=AP(AN,0):GOSUB 710
5900 TIME=WT-AW
5910 RETURN
6000 ' ----- 5 Neko death
6010 PN=AP(AN,1)        ' Sprite page
6020 GOSUB 510          ' Switch page
6030 GOSUB 310          ' Sound
6040 CT=CT+1:IF CT>10 THEN CT=2
6050 RETURN
6200 ' ----- 6 Neko death(END)
6210 WT=180             ' Wait time
6220 PN=AP(AN,1)        ' Sprite page
6230 GOSUB 510          ' Switch page
6240 S7=&B101110:SD=60:GOSUB 350:SOUND 9,12     ' Sound(Frequency specified)
6250 WT=300             ' Wait time
6260 PN=63              ' Sprite page
6270 GOSUB 510          ' Switch page
6280 S7=&B101110:SD=16:GOSUB 350:SOUND 9,13     ' Sound(Frequency specified)
6290 IF TIME<600 THEN 6290
6300 GOTO 7000
7000 ' ===== ===== ===== ===== End
7010 SOUND 8,0:SOUND 9,0
7020 COLOR 0,0,0:SCREEN 0
7030 IF MD THEN K$=INPUT$(1)
7100 ' Number of times selected.
7110 COLOR 15,0,0
7120 PRINT "Original ";AC(0)
7130 PRINT "Tsujino Akari ";AC(1)
7140 PRINT "Ringoro ";AC(2)
7150 PRINT "Rick Astley ";AC(3)
7160 PRINT "Kizuna Akari ";AC(4)
7170 PRINT "Neko death ";AC(5)
7190 PRINT "Small neko ";AC(6)-1
7200 PRINT "Last Small Neko probability ";CT
7210 END
